<?php // Invitation-database functions

function db_exec(&$db, $query) {
  $args = func_get_args();
  if (pg_query_params($db['connection'], $query, array_slice($args, 2)))
    return true;
  else
    return false;
}

function db_select(&$db, $query) {
  $args = func_get_args();
  if ($result = pg_query_params($db['connection'], $query, array_slice($args, 2)))
    return @pg_fetch_all($result);
  else
    return -1;
}

function db_connect(&$db) {
  $host = $db['host'];
  $port = $db['port'];
  $dbname = $db['database'];
  $user = $db['user'];
  $pwd  = $db['password'];

  if(!array_key_exists('requests', $db))
     $db['requests'] = 'requests';
  if(!array_key_exists('invitations', $db))
     $db['invitations'] = 'invitations';

  $db['connection'] = pg_pconnect("host=$host port=$port dbname='$dbname' user='$user' password='$pwd'");

  if ($db['connection'] === FALSE) {
        error_log(pg_last_error());
  } else {
     if(array_key_exists('schema', $db)) {
        $schema = $db['schema'];
        db_exec($db, "SET search_path TO '$schema'");
     }
  }
  return $db['connection'];
}

?>
