<?php
// process (invitations) main page
$page['header'] = LBL_PROCESS;
$page['content'] = '';

if (!db_connect($db)) {
  $page['errors'][] = ERROR_DB_CONNECT;
  return;
}

if (!purge_invitations($db)) {
  $page['errors'][] .= ERROR_PURGE_FAILED;
}

$accept_uiid = $_SESSION['accept_uiid'];

if (array_key_exists('deny', $_GET) and ($deny_uiid = $_GET['deny'])) {
  if (!$invitation = get_invitation($db, $deny_uiid)) {
    $page['errors'][] = ERROR_INVALID_UIID . ": " . $deny_uiid;
    return;
  }
  if (!deny_invitation($db, $deny_uiid)) {
    $page['errors'][] = ERROR_DELETE_UIID;
    return;
  }
  $page['content'] .= LBL_PROCESS_DENY . "<br>\n";
//  $page['content'] .= "<pre>" . print_r($invitation, true) . "</pre>\n";

  unset ($_SESSION['deny_uiid']);

} else if ($accept_uiid && $uuid) {
  if (!$invitation = get_invitation($db, $accept_uiid)) {
    $page['errors'][] = ERROR_INVALID_UIID . ": " . $accept_uiid;
    return;
  }
  $gr = new_grouper();
  if (!$gr->isConnected()) {
    $page['errors'][] = ERROR_GROUPER_CONNECT;
    return;
  }
  if (!$gr->addMember($invitation['group_id'], $uuid, $invitation['inviter'])) {
    $page['errors'][] = ERROR_GROUPER_ADDMEMBER;
    return;
  }
  $set_readpriv = $gr->setPrivilege($invitation['group_id'], $uuid, 'read', TRUE);
  $set_optoutpriv = $gr->setPrivilege($invitation['group_id'], $uuid, 'optout', TRUE);
  if (!$set_readpriv || !$set_optoutpriv) {
    $page['errors'][] = ERROR_GROUPER_SETPRIVILEGES;
    return;
  }
  if (!delete_invitation($db, $accept_uiid)) {
    $page['errors'][] = ERROR_DELETE_UIID;
    return;
  }
  unset ($_SESSION['accept_uiid']);

  $page['content'] .= LBL_PROCESS_ACCEPT . "<br>\n";
//  $page['content'] .= "<pre>" . print_r($invitation, true) . "</pre>\n";

  $page['content'] .= "<form method='post' action='members'>\n";
  $page['content'] .= "<input type=hidden name='group_id' value='" . $invitation['group_id'] . "'>\n";
  $page['content'] .= "<input type='submit' name='control' value='" . LBL_PROCESS_RETURN . "'>\n";
  $page['content'] .= "</form>\n";


} else {
  $page['errors'][] = ERROR_MISSING_UIID;

}

?>
